#include <stdio.h>
#include <stdlib.h>
#include <stdbool.h>
#include <string.h>
#include <fcntl.h>
#include <unistd.h>
#include <errno.h>
#include <sys/ioctl.h>
#include "GPIO_DRV.h"

void printCommand(){
	printf("Syntax:\n");
	printf("%s%s",
        "\ttestapp /setgpio pin_num value(1,0)\n",
        "\ttestapp /getgpio pin_num\n");
}

int main(int argc, char *argv[]){
	int pin_number, value;
	bool ret;	
	int handle;
	char *error;
	struct gpiodrv_arg gpiodata;

	handle = open("/dev/gpio_drv", O_RDWR);
	if(!handle){
		printf("Error in open gpio driver");
		exit(-1);
	}
	
	memset(&gpiodata, 0, sizeof(gpiodata));

	if(argc == 1){
		printf("Command Error!\n");
		printCommand();
		close(handle);
		return 0;
	}

	// command: testapp /enabletimer
	if(strcmp(argv[1],"/setgpio") == 0)
	{
		int level=0;
		ret=false;
		
		if(argc != 4){
			printf("Syntax Error!\n");
			printCommand();
			close(handle);
			return 0;
		}
		
		printf("set pin_number: %s\n", argv[2]);
		printf("set value: %s\n", argv[3]);

		gpiodata.gpio  = atoi(argv[2]);
		gpiodata.value = atoi(argv[3])? true : false;

		ret = ioctl(handle, IOCTL_GPIOSETVAL, &gpiodata);
		if (ret == -EFAULT)
			perror("set value failed\n");
			
	}
	else if(strcmp(argv[1],"/getgpio") == 0){
		if(argc != 3){
			printf("Syntax Error!\n");
			printCommand();
			close(handle);
			return 0;
		}

		printf("get pin_number: %s\n", argv[2]);
		gpiodata.gpio  = atoi(argv[2]);
		ret = ioctl(handle, IOCTL_GPIOGETVAL, &gpiodata);

		if(ret != -EFAULT)
			printf("get value: %s\n", (gpiodata.value?"true":"false"));
		else
			printf("get value: error\n");
			
	}
	else
	{
		printf("Unknown Command.\n");
		printCommand();
	}

	close(handle);
	return 0;
}
